Loading...
Searching...
No Matches
WritableCollection Class Reference
Inheritance diagram for WritableCollection:
[legend]
Collaboration diagram for WritableCollection:
[legend]

## Public Member Functions

| WriteCalendarMember (vCalendar $vcal, $create_resource, $do_scheduling=false, $segment_name=null, $log_action=false)
| WriteMember ( $resource, $create_resource, $segment_name=null, $log_action=true)
| WriteCalendarAlarms ( $dav_id, vCalendar $vcal)
| WriteCalendarAttendees ( $dav_id, vCalendar $vcal)
| actualDeleteCalendarMember ( $member_dav_name)
| whatChangedSince ( $some_old_token)
Public Member Functions inherited from DAVResource
| __construct ( $parameters=null, ?DAVResource $prefetched_collection=null)
| FromRow ($row)
| FromPath ($inpath)
| GetParentContainer ()
| FetchParentContainer ()
| Privileges ()
| HavePrivilegeTo ( $do_what, $any=null)
| NeedPrivilege ( $privilege, $any=null)
| BuildPrivileges ( $privilege_names=null, &$xmldoc=null)
| FetchSupportedMethods ()
| BuildSupportedMethods ()
| FetchSupportedReports ()
| BuildSupportedReports (&$reply)
| FetchTickets ()
| BuildTicketinfo (&$reply)
| IsLocked ( $depth=0)
| IsCollection ()
| IsPrincipal ()
| IsCalendar ()

## Static Private Member Functions

static | GetTZID (vComponent $comp)

## Additional Inherited Members

Static Public Member Functions inherited from DAVResource
static | BuildDeadPropertyXML ($property_name, $raw_string)
Protected Member Functions inherited from DAVResource
| FetchCollection ()
| FetchPrincipal ()
| FetchResource ()
| FetchDeadProperties ()
| FetchPrivileges ()
Protected Attributes inherited from DAVResource
| $dav_name
| $exists
| $unique_tag
| $resource
| $parent
| $resourcetypes
| $contenttype
| $bound_from

## Detailed Description

Definition at line 4 of file WritableCollection.php.

## Member Function Documentation

## actualDeleteCalendarMember()

WritableCollection::actualDeleteCalendarMember | ( |  | $member_dav_name | ) |

Writes the data to a member in the collection and returns the segment_name of the resource in our internal namespace.

Parameters

  vCalendar | $member_dav_name | The path to the resource to be deleted.

Returns
  boolean Success is true, or false on failure.

Definition at line 440 of file WritableCollection.php.

## GetTZID()

WritableCollection::GetTZID | ( | vComponent | $comp | ) |

static private

Get a TZID string from this VEVENT/VTODO/... component if we can

Parameters

  vComponent | $comp |

Returns
  The TZID value we found, or null

Definition at line 11 of file WritableCollection.php.

## whatChangedSince()

WritableCollection::whatChangedSince | ( |  | $some_old_token | ) |

Parameters

  unknown_type | $some_old_token |

Definition at line 478 of file WritableCollection.php.

## WriteCalendarAlarms()

WritableCollection::WriteCalendarAlarms | ( |  | $dav_id,
|  | vCalendar | $vcal )

Given a dav_id and an original vCalendar, pull out each of the VALARMs and write the values into the calendar_alarm table.

Returns
  null

Definition at line 337 of file WritableCollection.php.

## WriteCalendarAttendees()

WritableCollection::WriteCalendarAttendees | ( |  | $dav_id,
|  | vCalendar | $vcal )

Parse out the attendee property and write a row to the calendar_attendee table for each one.

Parameters

  int | $dav_id | The dav_id of the caldav_data we're processing
  | vComponent | The VEVENT or VTODO containing the ATTENDEEs

Returns
  null

Todo
  work out why we get duplicate ATTENDEE on one VEVENT

Definition at line 402 of file WritableCollection.php.

## WriteCalendarMember()

WritableCollection::WriteCalendarMember | ( | vCalendar | $vcal,
|  |  | $create_resource,
|  |  | $do_scheduling = false,
|  |  | $segment_name = null,
|  |  | $log_action = false )

Writes the data to a member in the collection and returns the segment_name of the resource in our internal namespace.

Parameters

  vCalendar | $vcal | The resource to be written.
  boolean | $create_resource | True if this is a new resource.
  boolean | $do_scheduling | True if we should also do scheduling for this write. Default false.
  string | $segment_name | The name of the resource within the collection, or null if this call should invent one based on the UID of the vCalendar.
  boolean | $log_action | Whether to log this action. Defaults to false since this is normally called in situations where one is writing secondary data.

Returns
  string The segment_name of the resource within the collection, as written, or false on failure.

From RFC2445 4.6.1: For cases where a "VEVENT" calendar component specifies a "DTSTART" property with a DATE data type but no "DTEND" property, the events non-inclusive end is the end of the calendar date specified by the "DTSTART" property. For cases where a "VEVENT" calendar component specifies a "DTSTART" property with a DATE-TIME data type but no "DTEND" property, the event ends on the same calendar date and time of day specified by the "DTSTART" property.

So we're looking for 'VALUE=DATE', to identify the duration, effectively.

Calculate what timezone to set, first, if possible

Definition at line 33 of file WritableCollection.php.

## WriteMember()

WritableCollection::WriteMember | ( |  | $resource,
|  |  | $create_resource,
|  |  | $segment_name = null,
|  |  | $log_action = true )

Writes the data to a member in the collection and returns the segment_name of the resource in our internal namespace.

A caller who wants scheduling not to happen for this write must already know they are dealing with a calendar, so should be calling WriteCalendarMember directly.

Parameters

  | $resource | mixed The resource to be written.
  | $create_resource | boolean True if this is a new resource.
  | $segment_name | The name of the resource within the collection, or false on failure.
  boolean | $log_action | Whether to log this action. Defaults to true since this is normally called in situations where one is writing primary data.

Returns
  string The segment_name that was given, or one that was assigned if null was given.

Definition at line 310 of file WritableCollection.php.

The documentation for this class was generated from the following file:

- inc/WritableCollection.php